<template>
  <Spinner v-if="isLoading"/>

  <div v-else-if="results" class="row mb-2">
    <h1>This is the posts list</h1>

    <div class="col-9 mb-4">
      <input type="text" v-model="searchQuery" class="form-control col-3" placeholder="Filter article.."/>
    </div>

    <div v-if="searchQuery" class="col-3 text-end">
      <button @click="clearSearch()" class="btn btn-secondary">Clear Filter</button>
    </div>

    <div v-for="post in filteredList" :key="post.id" class="col-md-6">
      <Post :post="post" />
    </div>
  </div>

  <div v-else>{{ error }}</div>
</template>

<script>
import useFetch from '../composable/use-fetch';
import useSearch from '../composable/use-search';

import Spinner from '@/components/Spinner.vue';
import Post from '@/components/Post.vue';

export default {
  components: {
    Spinner,
    Post
  },
  setup() {
    const { results, isLoading, error } = useFetch('https://jsonplaceholder.typicode.com/posts');

    const { searchQuery, filteredList } = useSearch(results, 'title');

    function clearSearch() {
      searchQuery.value = '';
    }

    return { results, isLoading, error, filteredList, searchQuery, clearSearch };
  },
}
</script>

